public class inverseSigmInp implements input { 
//sinus curve shifted to get output \in [0,1]
//(see +1.0/2.0)

public int counter;
public double wl;
public double stdDev;
public boolean useNoise;
public static java.util.Random rand=main.rand;


public void initRand(long seed){
rand=new java.util.Random(seed);
}

/*parameter specifies wavelength...
*/
public inverseSigmInp(int wavelength,double stdDev){
counter=0;
this.stdDev=stdDev;
useNoise=false;
if(stdDev!=.0)
  useNoise=true;
wl=(2.0*Math.PI)/(wavelength*1.0);
}

/*parameter specifies wavelength...
*/
public inverseSigmInp(int wavelength){
this(wavelength,.0);
}

public static double aboveZero(double in){
if(in<.0)
  return .0;
else
  return in;
}

/*This gives input to an individual, every 
  time step - over time a sigmoidal curve
*/
public double getVal(){
counter++;
if(!useNoise)
  return 1.0-((Math.sin(wl*(counter*1.0))+1.0)/2.0);
else
  return 1.0-aboveZero(((Math.sin(wl*(counter*1.0))+1.0)/2.0)+(rand.nextGaussian()*stdDev));
}

}